Index: branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 9161)
+++ branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 9168)
@@ -5,32 +5,46 @@
    !!                          their model equivalent 
    !!======================================================================
-
+   !! History :  1.0  !  2006-03  (K. Mogensen) Original code
+   !!             -   !  2006-05  (K. Mogensen, A. Weaver) Reformatted
+   !!             -   !  2006-10  (A. Weaver) Cleaning and add controls
+   !!             -   !  2007-03  (K. Mogensen) General handling of profiles
+   !!             -   !  2007-04  (G. Smith) Generalized surface operators
+   !!            2.0  !  2008-10  (M. Valdivieso) obs operator for velocity profiles
+   !!            3.4  !  2014-08  (J. While) observation operator for profiles in all vertical coordinates
+   !!             -   !                      Incorporated SST bias correction  
+   !!            3.6  !  2015-02  (M. Martin) Simplification of namelist and code
+   !!             -   !  2015-08  (M. Martin) Combined surface/profile routines.
+   !!            4.0  !  2017-11  (G. Madec) style only
    !!----------------------------------------------------------------------
-   !!   dia_obs_init : Reading and prepare observations
-   !!   dia_obs      : Compute model equivalent to observations
-   !!   dia_obs_wri  : Write observational diagnostics
-   !!   calc_date    : Compute the date of timestep in YYYYMMDD.HHMMSS format
-   !!   ini_date     : Compute the initial date YYYYMMDD.HHMMSS
-   !!   fin_date     : Compute the final date YYYYMMDD.HHMMSS
+
    !!----------------------------------------------------------------------
-   USE par_kind                 ! Precision variables
-   USE in_out_manager           ! I/O manager
-   USE par_oce
-   USE dom_oce                  ! Ocean space and time domain variables
-   USE obs_read_prof            ! Reading and allocation of profile obs
-   USE obs_read_surf            ! Reading and allocation of surface obs
-   USE obs_sstbias              ! Bias correction routine for SST 
-   USE obs_readmdt              ! Reading and allocation of MDT for SLA.
-   USE obs_prep                 ! Preparation of obs. (grid search etc).
-   USE obs_oper                 ! Observation operators
-   USE obs_write                ! Writing of observation related diagnostics
-   USE obs_grid                 ! Grid searching
-   USE obs_read_altbias         ! Bias treatment for altimeter
-   USE obs_profiles_def         ! Profile data definitions
-   USE obs_surf_def             ! Surface data definitions
-   USE obs_types                ! Definitions for observation types
-   USE mpp_map                  ! MPP mapping
-   USE sbc_oce                  ! Sea-ice fraction
-   USE lib_mpp                  ! For ctl_warn/stop
+   !!   dia_obs_init  : Reading and prepare observations
+   !!   dia_obs       : Compute model equivalent to observations
+   !!   dia_obs_wri   : Write observational diagnostics
+   !!   calc_date     : Compute the date of timestep in YYYYMMDD.HHMMSS format
+   !!   ini_date      : Compute the initial date YYYYMMDD.HHMMSS
+   !!   fin_date      : Compute the final date YYYYMMDD.HHMMSS
+   !!----------------------------------------------------------------------
+   USE par_kind       ! Precision variables
+   USE in_out_manager ! I/O manager
+   USE par_oce        ! ocean parameter
+   USE dom_oce        ! Ocean space and time domain variables
+   USE sbc_oce        ! Sea-ice fraction
+   !
+   USE obs_read_prof  ! Reading and allocation of profile obs
+   USE obs_read_surf  ! Reading and allocation of surface obs
+   USE obs_sstbias    ! Bias correction routine for SST 
+   USE obs_readmdt    ! Reading and allocation of MDT for SLA.
+   USE obs_prep       ! Preparation of obs. (grid search etc).
+   USE obs_oper       ! Observation operators
+   USE obs_write      ! Writing of observation related diagnostics
+   USE obs_grid       ! Grid searching
+   USE obs_read_altbias ! Bias treatment for altimeter
+   USE obs_profiles_def ! Profile data definitions
+   USE obs_surf_def   ! Surface data definitions
+   USE obs_types      ! Definitions for observation types
+   !
+   USE mpp_map        ! MPP mapping
+   USE lib_mpp        ! For ctl_warn/stop
 
    IMPLICIT NONE
@@ -43,51 +57,40 @@
    PUBLIC calc_date        ! Compute the date of a timestep
 
-   !! * Module variables
-   LOGICAL, PUBLIC :: ln_diaobs   !: Logical switch for the obs operator
-   LOGICAL :: ln_sstnight         !: Logical switch for night mean SST obs
-   LOGICAL :: ln_sla_fp_indegs    !: T=> SLA obs footprint size specified in degrees, F=> in metres
-   LOGICAL :: ln_sst_fp_indegs    !: T=> SST obs footprint size specified in degrees, F=> in metres
-   LOGICAL :: ln_sss_fp_indegs    !: T=> SSS obs footprint size specified in degrees, F=> in metres
-   LOGICAL :: ln_sic_fp_indegs    !: T=> sea-ice obs footprint size specified in degrees, F=> in metres
-
-   REAL(wp) :: rn_sla_avglamscl !: E/W diameter of SLA observation footprint (metres)
-   REAL(wp) :: rn_sla_avgphiscl !: N/S diameter of SLA observation footprint (metres)
-   REAL(wp) :: rn_sst_avglamscl !: E/W diameter of SST observation footprint (metres)
-   REAL(wp) :: rn_sst_avgphiscl !: N/S diameter of SST observation footprint (metres)
-   REAL(wp) :: rn_sss_avglamscl !: E/W diameter of SSS observation footprint (metres)
-   REAL(wp) :: rn_sss_avgphiscl !: N/S diameter of SSS observation footprint (metres)
-   REAL(wp) :: rn_sic_avglamscl !: E/W diameter of sea-ice observation footprint (metres)
-   REAL(wp) :: rn_sic_avgphiscl !: N/S diameter of sea-ice observation footprint (metres)
-
-   INTEGER :: nn_1dint       !: Vertical interpolation method
-   INTEGER :: nn_2dint       !: Default horizontal interpolation method
-   INTEGER :: nn_2dint_sla   !: SLA horizontal interpolation method 
-   INTEGER :: nn_2dint_sst   !: SST horizontal interpolation method 
-   INTEGER :: nn_2dint_sss   !: SSS horizontal interpolation method 
-   INTEGER :: nn_2dint_sic   !: Seaice horizontal interpolation method 
-   INTEGER, DIMENSION(imaxavtypes) ::   nn_profdavtypes   !: Profile data types representing a daily average
-   INTEGER :: nproftypes     !: Number of profile obs types
-   INTEGER :: nsurftypes     !: Number of surface obs types
-   INTEGER, DIMENSION(:), ALLOCATABLE :: &
-      & nvarsprof, &         !: Number of profile variables
-      & nvarssurf            !: Number of surface variables
-   INTEGER, DIMENSION(:), ALLOCATABLE :: &
-      & nextrprof, &         !: Number of profile extra variables
-      & nextrsurf            !: Number of surface extra variables
-   INTEGER, DIMENSION(:), ALLOCATABLE :: &
-      & n2dintsurf           !: Interpolation option for surface variables
-   REAL(wp), DIMENSION(:), ALLOCATABLE :: &
-      & zavglamscl, &        !: E/W diameter of averaging footprint for surface variables
-      & zavgphiscl           !: N/S diameter of averaging footprint for surface variables
-   LOGICAL, DIMENSION(:), ALLOCATABLE :: &
-      & lfpindegs, &         !: T=> surface obs footprint size specified in degrees, F=> in metres
-      & llnightav            !: Logical for calculating night-time averages
-
-   TYPE(obs_surf), PUBLIC, POINTER, DIMENSION(:) :: &
-      & surfdata, &          !: Initial surface data
-      & surfdataqc           !: Surface data after quality control
-   TYPE(obs_prof), PUBLIC, POINTER, DIMENSION(:) :: &
-      & profdata, &          !: Initial profile data
-      & profdataqc           !: Profile data after quality control
+   LOGICAL, PUBLIC :: ln_diaobs          !: Logical switch for the obs operator
+   LOGICAL         :: ln_sstnight        !  Logical switch for night mean SST obs
+   LOGICAL         :: ln_sla_fp_indegs   !  T=> SLA obs footprint size specified in degrees, F=> in metres
+   LOGICAL         :: ln_sst_fp_indegs   !  T=> SST obs footprint size specified in degrees, F=> in metres
+   LOGICAL         :: ln_sss_fp_indegs   !  T=> SSS obs footprint size specified in degrees, F=> in metres
+   LOGICAL         :: ln_sic_fp_indegs   !  T=> sea-ice obs footprint size specified in degrees, F=> in metres
+
+   REAL(wp) ::   rn_sla_avglamscl   ! E/W diameter of SLA observation footprint (metres)
+   REAL(wp) ::   rn_sla_avgphiscl   ! N/S diameter of SLA observation footprint (metres)
+   REAL(wp) ::   rn_sst_avglamscl   ! E/W diameter of SST observation footprint (metres)
+   REAL(wp) ::   rn_sst_avgphiscl   ! N/S diameter of SST observation footprint (metres)
+   REAL(wp) ::   rn_sss_avglamscl   ! E/W diameter of SSS observation footprint (metres)
+   REAL(wp) ::   rn_sss_avgphiscl   ! N/S diameter of SSS observation footprint (metres)
+   REAL(wp) ::   rn_sic_avglamscl   ! E/W diameter of sea-ice observation footprint (metres)
+   REAL(wp) ::   rn_sic_avgphiscl   ! N/S diameter of sea-ice observation footprint (metres)
+
+   INTEGER :: nn_1dint       ! Vertical interpolation method
+   INTEGER :: nn_2dint       ! Default horizontal interpolation method
+   INTEGER :: nn_2dint_sla   ! SLA horizontal interpolation method 
+   INTEGER :: nn_2dint_sst   ! SST horizontal interpolation method 
+   INTEGER :: nn_2dint_sss   ! SSS horizontal interpolation method 
+   INTEGER :: nn_2dint_sic   ! Seaice horizontal interpolation method 
+   INTEGER, DIMENSION(imaxavtypes) ::   nn_profdavtypes   ! Profile data types representing a daily average
+   INTEGER :: nproftypes     ! Number of profile obs types
+   INTEGER :: nsurftypes     ! Number of surface obs types
+   INTEGER , DIMENSION(:), ALLOCATABLE ::   nvarsprof, nvarssurf   ! Number of profile & surface variables
+   INTEGER , DIMENSION(:), ALLOCATABLE ::   nextrprof, nextrsurf   ! Number of profile & surface extra variables
+   INTEGER , DIMENSION(:), ALLOCATABLE ::   n2dintsurf             ! Interpolation option for surface variables
+   REAL(wp), DIMENSION(:), ALLOCATABLE ::   zavglamscl, zavgphiscl ! E/W & N/S diameter of averaging footprint for surface variables
+   LOGICAL , DIMENSION(:), ALLOCATABLE ::   lfpindegs              ! T=> surface obs footprint size specified in degrees, F=> in metres
+   LOGICAL , DIMENSION(:), ALLOCATABLE ::   llnightav              ! Logical for calculating night-time averages
+
+   TYPE(obs_surf), PUBLIC, POINTER, DIMENSION(:) ::   surfdata     !: Initial surface data
+   TYPE(obs_surf), PUBLIC, POINTER, DIMENSION(:) ::   surfdataqc   !: Surface data after quality control
+   TYPE(obs_prof), PUBLIC, POINTER, DIMENSION(:) ::   profdata     !: Initial profile data
+   TYPE(obs_prof), PUBLIC, POINTER, DIMENSION(:) ::   profdataqc   !: Profile data after quality control
 
    CHARACTER(len=6), PUBLIC, DIMENSION(:), ALLOCATABLE ::   cobstypesprof, cobstypessurf   !: Profile & surface obs types
@@ -110,11 +113,4 @@
       !! ** Action  : Read the namelist and call reading routines
       !!
-      !! History :
-      !!        !  06-03  (K. Mogensen) Original code
-      !!        !  06-05  (A. Weaver) Reformatted
-      !!        !  06-10  (A. Weaver) Cleaning and add controls
-      !!        !  07-03  (K. Mogensen) General handling of profiles
-      !!        !  14-08  (J.While) Incorporated SST bias correction  
-      !!        !  15-02  (M. Martin) Simplification of namelist and code
       !!----------------------------------------------------------------------
       INTEGER, PARAMETER ::   jpmaxnfiles = 1000    ! Maximum number of files for each obs type
@@ -124,5 +120,6 @@
       INTEGER :: jvar            ! Counter for variables
       INTEGER :: jfile           ! Counter for files
-
+      INTEGER :: jnumsstbias
+      !
       CHARACTER(len=128), DIMENSION(jpmaxnfiles) :: &
          & cn_profbfiles, &      ! T/S profile input filenames
@@ -138,5 +135,5 @@
          & clproffiles, &        ! Profile filenames
          & clsurffiles           ! Surface filenames
-
+         !
       LOGICAL :: ln_t3d          ! Logical switch for temperature profiles
       LOGICAL :: ln_s3d          ! Logical switch for salinity profiles
@@ -155,17 +152,11 @@
       LOGICAL :: llvar2          ! Logical for profile variable 1
       LOGICAL, DIMENSION(jpmaxnfiles) :: lmask ! Used for finding number of sstbias files
-
+      !
       REAL(dp) :: rn_dobsini     ! Obs window start date YYYYMMDD.HHMMSS
       REAL(dp) :: rn_dobsend     ! Obs window end date   YYYYMMDD.HHMMSS
-      REAL(wp), DIMENSION(jpi,jpj) :: &
-         & zglam1, &             ! Model longitudes for profile variable 1
-         & zglam2                ! Model longitudes for profile variable 2
-      REAL(wp), DIMENSION(jpi,jpj) :: &
-         & zgphi1, &             ! Model latitudes for profile variable 1
-         & zgphi2                ! Model latitudes for profile variable 2
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: &
-         & zmask1, &             ! Model land/sea mask associated with variable 1
-         & zmask2                ! Model land/sea mask associated with variable 2
-
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zglam1, zglam2   ! Model longitudes for profile variable 1 & 2
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zgphi1, zgphi2   ! Model latitudes  for profile variable 1 & 2
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zmask1, zmask2   ! Model land/sea mask associated with variable 1 & 2
+      !!
       NAMELIST/namobs/ln_diaobs, ln_t3d, ln_s3d, ln_sla,              &
          &            ln_sst, ln_sic, ln_sss, ln_vel3d,               &
@@ -191,6 +182,5 @@
          &            nn_msshc, rn_mdtcorr, rn_mdtcutoff,             &
          &            nn_profdavtypes
-
-      INTEGER :: jnumsstbias
+      !-----------------------------------------------------------------------
 
       !-----------------------------------------------------------------------
@@ -198,10 +188,10 @@
       !-----------------------------------------------------------------------
       ! Some namelist arrays need initialising
-      cn_profbfiles(:) = ''
-      cn_slafbfiles(:) = ''
-      cn_sstfbfiles(:) = ''
-      cn_sicfbfiles(:) = ''
-      cn_velfbfiles(:) = ''
-      cn_sssfbfiles(:)    = ''
+      cn_profbfiles  (:) = ''
+      cn_slafbfiles  (:) = ''
+      cn_sstfbfiles  (:) = ''
+      cn_sicfbfiles  (:) = ''
+      cn_velfbfiles  (:) = ''
+      cn_sssfbfiles  (:) = ''
       cn_sstbiasfiles(:) = ''
       nn_profdavtypes(:) = -1
@@ -213,14 +203,14 @@
       REWIND( numnam_ref )   ! Namelist namobs in reference namelist
       READ  ( numnam_ref, namobs, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namobs in reference namelist', lwp )
-
+901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namobs in reference namelist', lwp )
       REWIND( numnam_cfg )   ! Namelist namobs in configuration namelist
       READ  ( numnam_cfg, namobs, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namobs in configuration namelist', lwp )
+902   IF( ios >  0 )   CALL ctl_nam ( ios , 'namobs in configuration namelist', lwp )
       IF(lwm) WRITE ( numond, namobs )
 
-      IF ( .NOT. ln_diaobs ) THEN
-         IF(lwp) WRITE(numout,cform_war)
-         IF(lwp) WRITE(numout,*)' ln_diaobs is set to false so not calling dia_obs'
+      IF( .NOT.ln_diaobs ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'dia_obs_init : NO Observation diagnostic used'
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
          RETURN
       ENDIF
@@ -230,30 +220,30 @@
          WRITE(numout,*) 'dia_obs_init : Observation diagnostic initialization'
          WRITE(numout,*) '~~~~~~~~~~~~'
-         WRITE(numout,*) '          Namelist namobs : set observation diagnostic parameters' 
-         WRITE(numout,*) '             Logical switch for T profile observations                ln_t3d = ', ln_t3d
-         WRITE(numout,*) '             Logical switch for S profile observations                ln_s3d = ', ln_s3d
-         WRITE(numout,*) '             Logical switch for SLA observations                      ln_sla = ', ln_sla
-         WRITE(numout,*) '             Logical switch for SST observations                      ln_sst = ', ln_sst
-         WRITE(numout,*) '             Logical switch for Sea Ice observations                  ln_sic = ', ln_sic
-         WRITE(numout,*) '             Logical switch for velocity observations               ln_vel3d = ', ln_vel3d
-         WRITE(numout,*) '             Logical switch for SSS observations                      ln_sss = ', ln_sss
-         WRITE(numout,*) '             Global distribution of observations              ln_grid_global = ', ln_grid_global
-         WRITE(numout,*) '             Logical switch for obs grid search lookup ln_grid_search_lookup = ', ln_grid_search_lookup
+         WRITE(numout,*) '   Namelist namobs : set observation diagnostic parameters' 
+         WRITE(numout,*) '      Logical switch for T profile observations                ln_t3d = ', ln_t3d
+         WRITE(numout,*) '      Logical switch for S profile observations                ln_s3d = ', ln_s3d
+         WRITE(numout,*) '      Logical switch for SLA observations                      ln_sla = ', ln_sla
+         WRITE(numout,*) '      Logical switch for SST observations                      ln_sst = ', ln_sst
+         WRITE(numout,*) '      Logical switch for Sea Ice observations                  ln_sic = ', ln_sic
+         WRITE(numout,*) '      Logical switch for velocity observations               ln_vel3d = ', ln_vel3d
+         WRITE(numout,*) '      Logical switch for SSS observations                      ln_sss = ', ln_sss
+         WRITE(numout,*) '      Global distribution of observations              ln_grid_global = ', ln_grid_global
+         WRITE(numout,*) '      Logical switch for obs grid search lookup ln_grid_search_lookup = ', ln_grid_search_lookup
          IF (ln_grid_search_lookup) &
-            WRITE(numout,*) '             Grid search lookup file header                cn_gridsearchfile = ', cn_gridsearchfile
-         WRITE(numout,*) '             Initial date in window YYYYMMDD.HHMMSS               rn_dobsini = ', rn_dobsini
-         WRITE(numout,*) '             Final date in window YYYYMMDD.HHMMSS                 rn_dobsend = ', rn_dobsend
-         WRITE(numout,*) '             Type of vertical interpolation method                  nn_1dint = ', nn_1dint
-         WRITE(numout,*) '             Type of horizontal interpolation method                nn_2dint = ', nn_2dint
-         WRITE(numout,*) '             Rejection of observations near land switch               ln_nea = ', ln_nea
-         WRITE(numout,*) '             Rejection of obs near open bdys                 ln_bound_reject = ', ln_bound_reject
-         WRITE(numout,*) '             MSSH correction scheme                                 nn_msshc = ', nn_msshc
-         WRITE(numout,*) '             MDT  correction                                      rn_mdtcorr = ', rn_mdtcorr
-         WRITE(numout,*) '             MDT cutoff for computed correction                 rn_mdtcutoff = ', rn_mdtcutoff
-         WRITE(numout,*) '             Logical switch for alt bias                          ln_altbias = ', ln_altbias
-         WRITE(numout,*) '             Logical switch for sst bias                          ln_sstbias = ', ln_sstbias
-         WRITE(numout,*) '             Logical switch for ignoring missing files             ln_ignmis = ', ln_ignmis
-         WRITE(numout,*) '             Daily average types                             nn_profdavtypes = ', nn_profdavtypes
-         WRITE(numout,*) '             Logical switch for night-time SST obs               ln_sstnight = ', ln_sstnight
+            WRITE(numout,*) '      Grid search lookup file header                cn_gridsearchfile = ', cn_gridsearchfile
+         WRITE(numout,*) '      Initial date in window YYYYMMDD.HHMMSS               rn_dobsini = ', rn_dobsini
+         WRITE(numout,*) '      Final date in window YYYYMMDD.HHMMSS                 rn_dobsend = ', rn_dobsend
+         WRITE(numout,*) '      Type of vertical interpolation method                  nn_1dint = ', nn_1dint
+         WRITE(numout,*) '      Type of horizontal interpolation method                nn_2dint = ', nn_2dint
+         WRITE(numout,*) '      Rejection of observations near land switch               ln_nea = ', ln_nea
+         WRITE(numout,*) '      Rejection of obs near open bdys                 ln_bound_reject = ', ln_bound_reject
+         WRITE(numout,*) '      MSSH correction scheme                                 nn_msshc = ', nn_msshc
+         WRITE(numout,*) '      MDT  correction                                      rn_mdtcorr = ', rn_mdtcorr
+         WRITE(numout,*) '      MDT cutoff for computed correction                 rn_mdtcutoff = ', rn_mdtcutoff
+         WRITE(numout,*) '      Logical switch for alt bias                          ln_altbias = ', ln_altbias
+         WRITE(numout,*) '      Logical switch for sst bias                          ln_sstbias = ', ln_sstbias
+         WRITE(numout,*) '      Logical switch for ignoring missing files             ln_ignmis = ', ln_ignmis
+         WRITE(numout,*) '      Daily average types                             nn_profdavtypes = ', nn_profdavtypes
+         WRITE(numout,*) '      Logical switch for night-time SST obs               ln_sstnight = ', ln_sstnight
       ENDIF
       !-----------------------------------------------------------------------
@@ -265,54 +255,52 @@
       nsurftypes = COUNT( (/ln_sla, ln_sst, ln_sic, ln_sss /) )
 
-      IF (ln_sstbias) THEN 
+      IF( ln_sstbias ) THEN 
          lmask(:) = .FALSE. 
-         WHERE (cn_sstbiasfiles(:) /= '') lmask(:) = .TRUE. 
+         WHERE( cn_sstbiasfiles(:) /= '' )   lmask(:) = .TRUE. 
          jnumsstbias = COUNT(lmask) 
          lmask(:) = .FALSE. 
       ENDIF      
 
-      IF ( nproftypes == 0 .AND. nsurftypes == 0 ) THEN
-         IF(lwp) WRITE(numout,cform_war)
-         IF(lwp) WRITE(numout,*) ' ln_diaobs is set to true, but all obs operator logical flags', &
-            &                    ' ln_t3d, ln_s3d, ln_sla, ln_sst, ln_sic, ln_vel3d', &
-            &                    ' are set to .FALSE. so turning off calls to dia_obs'
-         nwarn = nwarn + 1
+      IF( nproftypes == 0 .AND. nsurftypes == 0 ) THEN
+         CALL ctl_warn( 'dia_obs_init: ln_diaobs is set to true, but all obs operator logical flags',   &
+            &           ' (ln_t3d, ln_s3d, ln_sla, ln_sst, ln_sic, ln_vel3d)',                          &
+            &           ' are set to .FALSE. so turning off calls to dia_obs'  )
          ln_diaobs = .FALSE.
          RETURN
       ENDIF
 
-      IF ( nproftypes > 0 ) THEN
-
-         ALLOCATE( cobstypesprof(nproftypes) )
-         ALLOCATE( ifilesprof(nproftypes) )
-         ALLOCATE( clproffiles(nproftypes,jpmaxnfiles) )
-
+      IF( nproftypes > 0 ) THEN
+         !
+         ALLOCATE( cobstypesprof(nproftypes)             )
+         ALLOCATE( ifilesprof   (nproftypes)             )
+         ALLOCATE( clproffiles  (nproftypes,jpmaxnfiles) )
+         !
          jtype = 0
-         IF (ln_t3d .OR. ln_s3d) THEN
+         IF( ln_t3d .OR. ln_s3d ) THEN
             jtype = jtype + 1
             CALL obs_settypefiles( nproftypes, jpmaxnfiles, jtype, 'prof  ', &
                &                   cn_profbfiles, ifilesprof, cobstypesprof, clproffiles )
          ENDIF
-         IF (ln_vel3d) THEN
+         IF( ln_vel3d ) THEN
             jtype = jtype + 1
             CALL obs_settypefiles( nproftypes, jpmaxnfiles, jtype, 'vel   ', &
                &                   cn_velfbfiles, ifilesprof, cobstypesprof, clproffiles )
          ENDIF
-
-      ENDIF
-
-      IF ( nsurftypes > 0 ) THEN
-
-         ALLOCATE( cobstypessurf(nsurftypes) )
-         ALLOCATE( ifilessurf(nsurftypes) )
-         ALLOCATE( clsurffiles(nsurftypes, jpmaxnfiles) )
-         ALLOCATE(n2dintsurf(nsurftypes))
-         ALLOCATE(zavglamscl(nsurftypes))
-         ALLOCATE(zavgphiscl(nsurftypes))
-         ALLOCATE(lfpindegs(nsurftypes))
-         ALLOCATE(llnightav(nsurftypes))
-
+         !
+      ENDIF
+
+      IF( nsurftypes > 0 ) THEN
+         !
+         ALLOCATE( cobstypessurf(nsurftypes)             )
+         ALLOCATE( ifilessurf   (nsurftypes)             )
+         ALLOCATE( clsurffiles  (nsurftypes,jpmaxnfiles) )
+         ALLOCATE( n2dintsurf   (nsurftypes)             )
+         ALLOCATE( zavglamscl   (nsurftypes)             )
+         ALLOCATE( zavgphiscl   (nsurftypes)             )
+         ALLOCATE( lfpindegs    (nsurftypes)             )
+         ALLOCATE( llnightav    (nsurftypes)             )
+         !
          jtype = 0
-         IF (ln_sla) THEN
+         IF( ln_sla ) THEN
             jtype = jtype + 1
             CALL obs_settypefiles( nsurftypes, jpmaxnfiles, jtype, 'sla   ', &
@@ -325,5 +313,5 @@
                &                  lfpindegs, llnightav )
          ENDIF
-         IF (ln_sst) THEN
+         IF( ln_sst ) THEN
             jtype = jtype + 1
             CALL obs_settypefiles( nsurftypes, jpmaxnfiles, jtype, 'sst   ', &
@@ -337,5 +325,5 @@
          ENDIF
 #if defined key_lim3 || defined key_cice
-         IF (ln_sic) THEN
+         IF( ln_sic ) THEN
             jtype = jtype + 1
             CALL obs_settypefiles( nsurftypes, jpmaxnfiles, jtype, 'sic   ', &
@@ -349,5 +337,5 @@
          ENDIF
 #endif
-         IF (ln_sss) THEN
+         IF( ln_sss ) THEN
             jtype = jtype + 1
             CALL obs_settypefiles( nsurftypes, jpmaxnfiles, jtype, 'sss   ', &
@@ -360,7 +348,6 @@
                &                  lfpindegs, llnightav )
          ENDIF
-
-      ENDIF
-
+         !
+      ENDIF
 
 
@@ -368,29 +355,25 @@
       ! Obs operator parameter checking and initialisations
       !-----------------------------------------------------------------------
-
-      IF ( ln_vel3d .AND. ( .NOT. ln_grid_global ) ) THEN
+      !
+      IF( ln_vel3d  .AND.  .NOT.ln_grid_global ) THEN
          CALL ctl_stop( 'Velocity data only works with ln_grid_global=.true.' )
          RETURN
       ENDIF
-
-      IF ( ln_grid_global ) THEN
-         CALL ctl_warn( 'ln_grid_global=T may cause memory issues when used with a large number of processors' )
-      ENDIF
-
-      IF ( ( nn_1dint < 0 ) .OR. ( nn_1dint > 1 ) ) THEN
-         CALL ctl_stop(' Choice of vertical (1D) interpolation method', &
-            &                    ' is not available')
-      ENDIF
-
-      IF ( ( nn_2dint < 0 ) .OR. ( nn_2dint > 6 ) ) THEN
-         CALL ctl_stop(' Choice of horizontal (2D) interpolation method', &
-            &                    ' is not available')
-      ENDIF
-
+      !
+      IF( ln_grid_global ) THEN
+         CALL ctl_warn( 'dia_obs_init: ln_grid_global=T may cause memory issues when used with a large number of processors' )
+      ENDIF
+      !
+      IF( nn_1dint < 0  .OR.  nn_1dint > 1 ) THEN
+         CALL ctl_stop('dia_obs_init: Choice of vertical (1D) interpolation method is not available')
+      ENDIF
+      !
+      IF( nn_2dint < 0  .OR.  nn_2dint > 6  ) THEN
+         CALL ctl_stop('dia_obs_init: Choice of horizontal (2D) interpolation method is not available')
+      ENDIF
+      !
       CALL obs_typ_init
-      IF(ln_grid_global) THEN
-         CALL mppmap_init
-      ENDIF
-
+      IF( ln_grid_global )   CALL mppmap_init
+      !
       CALL obs_grid_setup( )
 
@@ -398,14 +381,12 @@
       ! Depending on switches read the various observation types
       !-----------------------------------------------------------------------
-
-      IF ( nproftypes > 0 ) THEN
-
-         ALLOCATE(profdata(nproftypes))
-         ALLOCATE(profdataqc(nproftypes))
-         ALLOCATE(nvarsprof(nproftypes))
-         ALLOCATE(nextrprof(nproftypes))
-
+      !
+      IF( nproftypes > 0 ) THEN
+         !
+         ALLOCATE( profdata  (nproftypes) , nvarsprof (nproftypes) )
+         ALLOCATE( profdataqc(nproftypes) , nextrprof (nproftypes) )
+         !
          DO jtype = 1, nproftypes
-
+            !
             nvarsprof(jtype) = 2
             IF ( TRIM(cobstypesprof(jtype)) == 'prof' ) THEN
@@ -431,6 +412,6 @@
                zmask2 = vmask
             ENDIF
-
-            !Read in profile or profile obs types
+            !
+            ! Read in profile or profile obs types
             CALL obs_rea_prof( profdata(jtype), ifilesprof(jtype),       &
                &               clproffiles(jtype,1:ifilesprof(jtype)), &
@@ -439,9 +420,9 @@
                &               ln_ignmis, ln_s_at_t, .FALSE., &
                &               kdailyavtypes = nn_profdavtypes )
-
+               !
             DO jvar = 1, nvarsprof(jtype)
                CALL obs_prof_staend( profdata(jtype), jvar )
             END DO
-
+            !
             CALL obs_pre_prof( profdata(jtype), profdataqc(jtype), &
                &               llvar1, llvar2, &
